<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<style>
    body {}

    #app {
        display: flex;
        flex-direction: row;
    }

    .draw {
        background-color: #000;
    }

    #panel {
        padding: 5px;
    }

    .particle-control {
        display: flex;
    }

    .particle-control .label {
        width: 50px;
    }

    .particle-control .control {
        flex: 1;
    }
</style>
<!-- <script src="https://cdnjs.cloudflare.com/ajax/libs/paper.js/0.12.17/paper-full.min.js"
    integrity="sha512-NApOOz1j2Dz1PKsIvg1hrXLzDFd62+J0qOPIhm8wueAnk4fQdSclq6XvfzvejDs6zibSoDC+ipl1dC66m+EoSQ=="
    crossorigin="anonymous" referrerpolicy="no-referrer"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/fabric.js/5.3.1/fabric.min.js"
    integrity="sha512-CeIsOAsgJnmevfCi2C7Zsyy6bQKi43utIjdA87Q0ZY84oDqnI0uwfM9+bKiIkI75lUeI00WG/+uJzOmuHlesMA=="
    crossorigin="anonymous" referrerpolicy="no-referrer"></script> -->
<script src="https://pixijs.download/release/pixi.js"></script>
<script src="https://cdn.jsdelivr.net/npm/pixi-filters@5.2.1/dist/browser/pixi-filters.min.js"></script>
<body>
    <div id="app">
        <div id='panel'></div>
        <div class="draw"><canvas id="canvas" width="500px" height="500" /></div>
        <div class="draw" id="alternative">
            <!-- <canvas id="canvasAlter" width="500px" height="500" /> -->
        </div>
    </div>
    <script>
        let types = [
            ['yellow', '#fffb63e6', 200, 4],
            ['red', '#ff1717e3', 200, 5],
            ['green', '#3caf0eb5', 200, 5],
            ['blue', '#4171ffe3', 300, 3],
            ['white', '#ffffffc0', 600, 2]
        ];

        let particlesName = {};

        let p = document.getElementById('panel');
        let particles = [];

        let ctx = document.getElementById('canvas').getContext('2d');
        let draw = (x, y, c, s) => {
            ctx.fillStyle = c
            ctx.fillRect(x, y, s, s)

            graphics.beginFill(c);
            graphics.drawCircle(x, y, s / 2);
            graphics.endFill();
        }

        let graphics = new PIXI.Graphics();

        graphics.filters = [
                new PIXI.filters.GlowFilter({ distance: 35, outerStrength: 2 })                
            ];


        let particle = (x, y, c, s) => {
            // PaperJS
            // new Path.Circle({
            //     center: [x, y],
            //     radius: s / 2,
            //     fillColor: c,
            // })

            // FabricJS
            // new fabric.Rect({
            //     left: x,
            //     top: y,
            //     fill: c,
            //     width: s,
            //     height: s
            // })
           
            return {
                'x': x, 'y': y,
                'vx': 0, 'vy': 0,
                'color': c, size: s,
                // 'o': obj
            }
        }
        let random = () => {
            return Math.random() * 400 + 50
        }

        let create = (number, color, s) => {
            let group = [];
            s ||= 5;
            for (let i = 0; i < number; i++) {
                group.push(particle(random(), random(), color, s));
                particles.push(group[i])
            }
            return group;
        }

        let rule = (particles1, particles2, g) => {
            for (let i = 0; i < particles1.length; i++) {
                let fx = fy = 0;
                let a = particles1[i];
                for (let j = 0; j < particles2.length; j++) {
                    let b = particles2[j],
                        dx = a.x - b.x,
                        dy = a.y - b.y;

                    let d = Math.sqrt(dx * dx + dy * dy);

                    if (d > 0 && d < 70) {
                        let F = g * 1 / d;
                        fx += (F * dx)
                        fy += (F * dy)
                    }
                }
                a.vx = (a.vx + fx) * 0.5
                a.vy = (a.vy + fy) * 0.5
                a.x += a.vx;
                a.y += a.vy;

                if (a.x <= 0 || a.x >= 500) { a.vx *= -1 };
                if (a.y <= 0 || a.y >= 500) { a.vy *= -1 };
            }
        }

        let rules = {
            'green:green': -0.32,
            'green:red': -0.20,
            'green:yellow': 0.34,

            'red:red': -0.1,
            'red:yellow': 0.1,

            'yellow:yellow': 0.15,
            'yellow:green': -0.20,
            'yellow:blue': 0.01,

            'blue:blue': -0.3,
            'blue:green': 0.32,
            'blue:yellow': -0.9,
            'blue:red': -0.2,
            'blue:white': 0.017,

            'white:blue': 0.017,
            'white:red': -0.017,
            'white:white': 0.017,
            'white:green': 0.017,
            'white:yellow': 0.027,
        };


        p.addEventListener('change', (e) => {
            rules[`${e.target.dataset.src}:${e.target.dataset.dst}`] = e.target.value;
        });
        p.addEventListener('click', (e) => {
            if (e.target.dataset.zero != null) {
                document.querySelector(`input[name='${e.target.dataset.zero}']`).value = rules[`${e.target.dataset.zero}`] = 0.0
            }
        });

        // Only executed our code once the DOM is ready.
        // paper.install(window);

        // Get a reference to the canvas object
        // var canvas = document.getElementById('canvasAlter');
        // var canvas = new fabric.StaticCanvas('canvasAlter');
        // Create an empty project and a view for the canvas:
        // paper.setup(canvas);

        let app = new PIXI.Application({ antialias: true, width: 500, height: 500 });
        document.getElementById('alternative').appendChild(app.view);

        
        p.innerHTML = types.reduce((str, srcType) => {
            particlesName[srcType[0]] = create(srcType[2], srcType[1], srcType[3]);
            particlesName[srcType[0]].forEach(p => {
                // canvas.add(p.o);
                // console.log(p.o.x, p.o.y)
                // app.stage.addChild(p.o);
            });
            app.stage.addChild(graphics);

            let children = types.reduce((subStr, dstType) => {
                rules[`${srcType[0]}:${dstType[0]}`] ||= 0;
                return subStr + `<div class='particle-control'>
                    <div class='label'>${dstType[0]}</div>
                    <button class="control" data-zero='${srcType[0]}:${dstType[0]}' type='button'>0</button>
                    <div class="control">
                        <input
                            type="range"
                            min="-0.5"
                            max="0.5"
                            step="0.01"
                            name="${srcType[0]}:${dstType[0]}"
                            data-src='${srcType[0]}' 
                            data-dst='${dstType[0]}' 
                            value='${rules[srcType[0] + ':' + dstType[0]]}'
                        />
                    </div>                    
                </div>`
            }, '');
            return str + `
                <div>
                    <h4>${srcType[0]}</h4>
                    ${children}         
                </div> 
            `
        }, '');

        let update = function () {
            Object.keys(rules).forEach(key => {
                let ab = key.split(':');
                rule(particlesName[ab[0]], particlesName[ab[1]], rules[key])
            });

            ctx.clearRect(0, 0, 500, 500);
            graphics.clear()
            for (let i = 0; i < particles.length; i++) {
                let p = particles[i];

                // Native
                draw(p.x, p.y, p.color, p.size)

                // PaperJS / PixiJS
                // p.o.position.x = p.x;
                // p.o.position.y = p.y;

                // FabricJS
                // p.o.left = p.x;
                // p.o.top = p.y;                
            }
            // FabricJS
            // canvas.renderAll()

            requestAnimationFrame(update)
        }
        update()

        // app.ticker.add((delta) => {
           
        // });

    </script>

</body>

</html>